<script setup lang="ts">
import ParameterSchemaFormComponent from "@/components/parameter-schema/ParameterSchemaFormComponent.vue";
import { DocumentationEnum, NextflowVersion } from "@/client/types.gen";
import { onMounted, reactive, watch } from "vue";
import { useRouter } from "vue-router";
import { Toast } from "bootstrap";
import { useWorkflowExecutionStore } from "@/stores/workflowExecutions";
import BootstrapToast from "@/components/BootstrapToast.vue";
import { useWorkflowStore } from "@/stores/workflows";
import type {
  NestedWorkflowParameters,
  WorkflowMetaParameters,
} from "@/types/WorkflowParameters";

const executionRepository = useWorkflowExecutionStore();
const workflowRepository = useWorkflowStore();
const props = defineProps<{
  versionId: string;
  workflowId: string;
  workflowModeId?: string;
}>();

const router = useRouter();
let errorToast: Toast | null = null;

const versionState = reactive<{
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  parameterSchema?: Record<string, any>;
  loading: boolean;
  workflowExecutionError?: string;
  errorText: string;
}>({
  parameterSchema: undefined,
  loading: false,
  workflowExecutionError: undefined,
  errorText: "",
});

watch(
  () => props.workflowModeId,
  (newModeId, oldModeId) => {
    if (newModeId !== oldModeId) {
      downloadParameterSchema();
    }
  },
);

function downloadParameterSchema() {
  versionState.loading = true;
  Promise.all([
    workflowRepository
      .fetchWorkflowDocumentation(
        props.workflowId,
        props.versionId,
        DocumentationEnum.PARAMETER_SCHEMA_JSON,
        props.workflowModeId,
      )
      .then((schema) => {
        versionState.parameterSchema = schema;
      }),
    workflowRepository.fetchWorkflowDocumentation(
      props.workflowId,
      props.versionId,
      DocumentationEnum.CLOWM_INFO_JSON,
    ),
  ]).finally(() => {
    versionState.loading = false;
  });
}

function startWorkflow(
  parameters: NestedWorkflowParameters,
  metaParameters: WorkflowMetaParameters,
) {
  if (props.versionId) {
    versionState.workflowExecutionError = undefined;
    versionState.loading = true;
    executionRepository
      .startExecution({
        workflow_version_id: props.versionId,
        parameters: parameters,
        notes: metaParameters.notes,
        logs_s3_path: metaParameters.logs_s3_path,
        debug_s3_path: metaParameters.debug_s3_path,
        provenance_s3_path: metaParameters.provenance_s3_path,
        mode_id: props.workflowModeId,
      })
      .then(() => {
        router.push({
          name: "workflow-executions",
        });
      })
      .catch((err) => {
        console.error(err);
        versionState.errorText = err.response?.data?.["detail"] ?? "";
        errorToast?.show();
      })
      .finally(() => {
        versionState.loading = false;
      });
  }
}

onMounted(() => {
  errorToast = new Toast("#workflowExecutionViewErrorToast");
  downloadParameterSchema();
});
</script>

<template>
  <bootstrap-toast
    toast-id="workflowExecutionViewErrorToast"
    color-class="danger"
  >
    <template #default>Error starting workflow</template>
    <template #body>
      There was an error with starting the workflow execution:<br />
      "{{ versionState.errorText }}"
    </template>
  </bootstrap-toast>
  <parameter-schema-form-component
    :schema="versionState.parameterSchema"
    :loading="versionState.loading"
    allow-notes
    :nextflow-version="
      workflowRepository.versionMapping[versionId]?.nextflow_version ??
      NextflowVersion['24_04_2']
    "
    :clowm-info="
      workflowRepository.documentationFiles[versionId]?.[
        DocumentationEnum.CLOWM_INFO_JSON
      ]
    "
    :parameter-extension="
      workflowRepository.versionMapping[versionId]?.parameter_extension ??
      undefined
    "
    :workflow-id="props.workflowId"
    @start-workflow="startWorkflow"
  />
</template>

<style scoped></style>
